"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Logger_prefix, _Logger_level;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Verbosity = void 0;
var Verbosity;
(function (Verbosity) {
    Verbosity[Verbosity["ERROR"] = 0] = "ERROR";
    Verbosity[Verbosity["WARN"] = 1] = "WARN";
    Verbosity[Verbosity["INFO"] = 2] = "INFO";
    Verbosity[Verbosity["DEBUG"] = 3] = "DEBUG";
    Verbosity[Verbosity["TRACE"] = 4] = "TRACE";
})(Verbosity = exports.Verbosity || (exports.Verbosity = {}));
class Logger {
    constructor() {
        _Logger_prefix.set(this, () => "");
        _Logger_level.set(this, Verbosity.ERROR);
        this.setPrefix = (func) => {
            if (typeof func !== "function") {
                throw new Error("Prefix must be a function");
            }
            __classPrivateFieldSet(this, _Logger_prefix, func, "f");
        };
        this.setVerbosity = (verbosityLevel) => {
            __classPrivateFieldSet(this, _Logger_level, verbosityLevel, "f");
        };
        this.error = (...args) => {
            if (__classPrivateFieldGet(this, _Logger_level, "f") >= Verbosity.ERROR) {
                console.error(__classPrivateFieldGet(this, _Logger_prefix, "f").call(this), ...args);
            }
        };
        this.warn = (...args) => {
            if (__classPrivateFieldGet(this, _Logger_level, "f") >= Verbosity.WARN) {
                console.warn(__classPrivateFieldGet(this, _Logger_prefix, "f").call(this), ...args);
            }
        };
        this.info = (...args) => {
            if (__classPrivateFieldGet(this, _Logger_level, "f") >= Verbosity.INFO) {
                console.info(__classPrivateFieldGet(this, _Logger_prefix, "f").call(this), ...args);
            }
        };
        this.debug = (...args) => {
            if (__classPrivateFieldGet(this, _Logger_level, "f") >= Verbosity.DEBUG) {
                console.debug(__classPrivateFieldGet(this, _Logger_prefix, "f").call(this), ...args);
            }
        };
        this.trace = (...args) => {
            if (__classPrivateFieldGet(this, _Logger_level, "f") >= Verbosity.TRACE) {
                console.trace(__classPrivateFieldGet(this, _Logger_prefix, "f").call(this), ...args);
            }
        };
    }
}
_Logger_prefix = new WeakMap(), _Logger_level = new WeakMap();
exports.default = Logger;
//# sourceMappingURL=logger.js.map